# TODO
# - complete docs and tests (missing BRs)
# - split back to subpackages (python-tkinter, etc deps)
# - package zsh completion
#
# Conditional build:
%bcond_without	doc	# Sphinx documentation
%bcond_with	tests	# unit tests (some failures)

Summary:	Twisted - a networking engine written in Python
Summary(pl.UTF-8):	Twisted - silnik sieciowy napisany w Pythonie
Name:		python3-twisted
Version:	22.4.0
Release:	1
License:	MIT
Group:		Libraries/Python
#Source0Download: https://pypi.org/simple/Twisted/
Source0:	https://files.pythonhosted.org/packages/source/T/Twisted/Twisted-%{version}.tar.gz
# Source0-md5:	f75194d2beb4d9bd0f0f02d6a2eff245
URL:		https://twistedmatrix.com/
BuildRequires:	python3-modules >= 1:3.7
BuildRequires:	python3-setuptools
%if %{with tests}
BuildRequires:	python3-attrs >= 19.2.0
BuildRequires:	python3-automat >= 0.8.0
BuildRequires:	python3-constantly >= 15.1
# TODO
BuildRequires:	python3-cython-test-exception-raiser >= 1.0.2
BuildRequires:	python3-cython-test-exception-raiser < 2
BuildRequires:	python3-hyperlink >= 17.1.1
BuildRequires:	python3-incremental >= 21.3.0
BuildRequires:	python3-pyhamcrest >= 1.9.0
BuildRequires:	python3-zope.interface >= 4.4.2
# conch
BuildRequires:	python3-appdirs >= 1.4.0
BuildRequires:	python3-bcrypt >= 3.0.0
BuildRequires:	python3-cryptography >= 2.6
BuildRequires:	python3-pyasn1
# conch_nacl
BuildRequires:	python3-PyNaCl
# http2
BuildRequires:	python3-h2 >= 3.0
BuildRequires:	python3-h2 < 5.0
BuildRequires:	python3-priority >= 1.1.0
BuildRequires:	python3-priority < 2.0
# serial
BuildRequires:	python3-serial >= 3.0
# tls
BuildRequires:	python3-idna >= 2.4
BuildRequires:	python3-pyOpenSSL >= 16.0.0
BuildRequires:	python3-service_identity >= 18.1.0
%endif
BuildRequires:	rpmbuild(macros) >= 1.714
%if %{with doc}
# TODO
BuildRequires:	python3-pydoctor >= 21.9.0
BuildRequires:	python3-sphinx_rtd_theme >= 0.5
BuildRequires:	python3-readthedocs-sphinx-ext >= 2.1
BuildRequires:	sphinx-pdg >= 4.1.2
%endif
Requires:	python3-modules >= 1:3.7
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Twisted is a networking engine written in Python, supporting numerous
protocols. It contains a web server, numerous chat clients, chat
servers, mail servers and more.

%description -l pl.UTF-8
Twisted to napisany w Pythonie silnik sieciowy, obsługujący wiele
protokołów. Zawiera serwer WWW, wiele klientów czatów, serwery czatów,
serwery pocztowe itp.

%package apidocs
Summary:	Documentation for Twisted networking engine
Summary(pl.UTF-8):	Dokumentacja do silnika sieciowego Twisted
Group:		Documentation

%description apidocs
Documentation for Twisted networking engine.

%description apidocs -l pl.UTF-8
Dokumentacja do silnika sieciowego Twisted.

%prep
%setup -q -n Twisted-%{version}

%{__sed} -i -e '/^_git_reference =/,/^)/ c _git_reference="%{version}"' docs/conf.py

%build
%py3_build

%if %{with tests}
PYTHONPATH=$(pwd)/src \
%{__python3} -m twisted.trial --reactor=default --reporter=verbose twisted
%endif

%if %{with doc}
PYTHONPATH=$(pwd)/src \
%{__make} -C docs html
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_mandir}/man1

%py3_install

%{__rm} -r $RPM_BUILD_ROOT%{py3_sitescriptdir}/twisted/*/test
%{__rm} $RPM_BUILD_ROOT%{py3_sitescriptdir}/twisted/python/twisted-completion.zsh

# install man pages
for s in conch core mail; do
	for f in docs/$s/man/*.1 ; do
		cp -p "$f" $RPM_BUILD_ROOT%{_mandir}/man1/$(basename $f .1)-3.1
	done
done

for f in $RPM_BUILD_ROOT%{_bindir}/* ; do
	[ "${f%%-2}" != "$f" ] || %{__mv} "$f" "${f}-3"
done

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc LICENSE NEWS.rst README.rst
%attr(755,root,root) %{_bindir}/cftp-3
%attr(755,root,root) %{_bindir}/ckeygen-3
%attr(755,root,root) %{_bindir}/conch-3
%attr(755,root,root) %{_bindir}/mailmail-3
%attr(755,root,root) %{_bindir}/pyhtmlizer-3
%attr(755,root,root) %{_bindir}/tkconch-3
%attr(755,root,root) %{_bindir}/trial-3
%attr(755,root,root) %{_bindir}/twist-3
%attr(755,root,root) %{_bindir}/twistd-3
%{py3_sitescriptdir}/twisted
%{py3_sitescriptdir}/Twisted-%{version}-py*.egg-info
%{_mandir}/man1/cftp-3.1*
%{_mandir}/man1/ckeygen-3.1*
%{_mandir}/man1/conch-3.1*
%{_mandir}/man1/mailmail-3.1*
%{_mandir}/man1/pyhtmlizer-3.1*
%{_mandir}/man1/tkconch-3.1*
%{_mandir}/man1/trial-3.1*
%{_mandir}/man1/twistd-3.1*

%if %{with doc}
%files apidocs
%defattr(644,root,root,755)
%doc docs/_build/html/{_downloads,_images,_static,conch,core,historic,installation,mail,names,pair,web,words,*.html,*.js}
%endif
%changelog
* Mon Apr 07 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python3-twisted.git;a=log;h=master

* Mon Apr 07 2025 Jan Rękorajski <baggins@pld-linux.org> e034312
- rel 1

* Wed Apr 27 2022 Jakub Bogusz <qboosh@pld-linux.org> aa1d45d
- started preparing Twisted 22.4.0

* Wed Apr 27 2022 Jakub Bogusz <qboosh@pld-linux.org> 7bda8fd
- python2 note, updated URLs, rpm version for noarch subpackage

* Wed Mar 30 2022 Jan Rękorajski <baggins@pld-linux.org> 1c50ac0
- rebuild with tests and docs

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> 581e373
- rebuild with python 3.10

* Sat Nov 20 2021 Jan Rękorajski <baggins@pld-linux.org> dd372cc
- rebuild with separate debuginfo build-ids

* Sun Feb 28 2021 Jan Rękorajski <baggins@pld-linux.org> 323e003
- unconditional noarch subpackages

* Sat Feb 27 2021 Jan Rękorajski <baggins@pld-linux.org> 23641b0
- release 2 (by relup.sh)

* Wed Mar 25 2020 Jakub Bogusz <qboosh@pld-linux.org> ca26dd2
- updated to 20.3.0
- removed outdated doc-lore-man-fix patch
- added python3- and -apidocs packages

* Wed Mar 18 2020 Jakub Bogusz <qboosh@pld-linux.org> 7c8c31c
- pl, updated Zope-Interface package name

* Sun Nov 29 2015 Jacek Konieczny <jajcus@jajcus.net> 6e5b6a0
- BR: rpmbuild(macros) >= 1.710

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> 5f0dc48
- automatic change: use py_build/py_install macros

* Sun Nov 23 2014 Elan Ruusamäe <glen@delfi.ee> 99b92e0
- new, version 14.0.2

